import os
import re
import fnmatch
from ..constraint import PatternConstraint
from ..helpers import RegexType


class FilepathConstraint(PatternConstraint):

    # Public

    def __init__(self, basedir=None):
        self.__basedir = basedir
        super().__init__()

    def extend(self, name, value):
        if name == 'filepath':
            self._include.append(value)
        if name == 'notfilepath':
            self._exclude.append(value)

    # Protected

    # TODO: don't work with pattern like './pattern'
    def _match(self, emitter, pattern):
        if isinstance(pattern, RegexType):
            if re.search(pattern, emitter.filepath):
                return True
        else:
            if os.path.isabs(pattern):
                # TODO: remove no cover
                pattern = os.path.relpath(pattern, start=self.__basedir)  # pragma: no cover
            # TODO: it's not working like glob, bug?
            if fnmatch.fnmatch(emitter.filepath, pattern):
                return True
        return False
