import re
from ..constraint import PatternConstraint
from ..helpers import RegexType


class ObjnameConstraint(PatternConstraint):

    # Public

    def extend(self, name, value):
        if name == 'objname':
            self._include.append(value)
        if name == 'notobjname':
            self._exclude.append(value)

    # Protected

    def _match(self, emitter, pattern):
        if isinstance(pattern, RegexType):
            if re.search(pattern, emitter.objname):
                return True
        else:
            if pattern == emitter.objname:
                return True
        return False
