import os
import unittest
from unittest.mock import Mock
from importlib import import_module
component = import_module('run_find.files.maxdepth')


class MaxdepthConstraintTest(unittest.TestCase):

    # Actions

    def setUp(self):
        # Depth is 2
        self.emitter = Mock(filepath=os.path.join('file', 'path'))
        self.constraint = component.MaxdepthConstraint()

    # Tests

    def test___call___with_maxdept(self):
        self.constraint.extend('maxdepth', 2)
        self.constraint(self.emitter)
        self.assertFalse(self.emitter.skip.called)
        self.assertFalse(self.emitter.stop.called)

    def test___call___with_maxdept_skip(self):
        self.constraint.extend('maxdepth', 1)
        self.constraint(self.emitter)
        self.assertTrue(self.emitter.skip.called)
        self.assertTrue(self.emitter.stop.called)
