import unittest
from functools import partial
from unittest.mock import patch
from importlib import import_module
component = import_module('run_find.files.task')


class FindFilesTaskTest(unittest.TestCase):

    # Actions

    def setUp(self):
        self.args = ('arg1',)
        self.kwargs = {'kwarg1': 'kwarg1'}
        self.ptask = partial(component.FindFilesTask, meta_module=None)

    # Tests

    @patch.object(component, 'find_files')
    def test___call___with_mode_is_strings(self, find_files):
        task = self.ptask()
        result = task(*self.args, **self.kwargs)
        self.assertEqual(result, find_files.return_value)
        find_files.assert_called_with(*self.args, **self.kwargs)
